## ros-melodic-controller-manager 0.18.3

=== debian/changelog ===
ros-melodic-controller-manager (0.18.3-1stretch) stretch; urgency=high

  * Update docs in hardware_interface
  * Contributors: Franz Pucher

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 05 Dec 2020 00:00:00 -0000

ros-melodic-controller-manager (0.18.2-1stretch) stretch; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 16 Aug 2020 23:00:00 -0000

ros-melodic-controller-manager (0.18.1-1stretch) stretch; urgency=high

  * Add function specifiers and modernize constructors (#430 <https://github.com/ros-controls/ros_control/issues/430>)
    * Add override specifiers & default constructors
    * Delete ControllerBase copy & move ctors
    * Remove unnecessary default constructors
    * Modernize additional constructors
    * Revert ImuSensorHandle::Data::Data() = default
    * Remove unnecessary default overridden constructors
    * Remove semicolon after function body
  * Contributors: Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 08 May 2020 23:00:00 -0000

ros-melodic-controller-manager (0.18.0-1stretch) stretch; urgency=high

  * enable spawner to wait indefinitely if requested (#428 <https://github.com/ros-controls/ros_control/issues/428>)
    rospy.wait_for_service does not allow for 0 to wait indefinitely.
    Instead, None has to be passed explicitly.
    By personal request of three maintainers extended to include documentation
    and the alternative argument --no-timeout.
  * Bump CMake version to avoid CMP0048 (#427 <https://github.com/ros-controls/ros_control/issues/427>)
  * Contributors: Michael Görner, Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 15 Apr 2020 23:00:00 -0000

ros-melodic-controller-manager (0.17.0-1stretch) stretch; urgency=high

  * Use auto keyword
  * Use default member initializers
  * Replace boost with std
  * Replace boost mutexes & locks with std
  * Replace boost::bind with std::bind
  * Contributors: AbhinavSingh, Bence Magyar, Matt Reynolds, suab321321

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 Feb 2020 00:00:00 -0000

ros-melodic-controller-manager (0.16.0-1stretch) stretch; urgency=high

  * Use range-based for loops in controller_manager
  * Resolve Boost dependency issues
  * Update dependencies
    - Dependencies needed to compile are <build_depend>
    - Dependencies used in public headers are <build_export_depend>
    - Dependencies needed to link or run are <exec_depend>
  * Merge branch 'melodic-devel' into catkin-lint
  * Add ${catkin_EXPORTED_TARGETS} dependencies
  * Update package dependencies
  * Add missing roscpp & rospy dependencies
  * Prefer nullptr for null pointers
  * Replace header guard with #pragma once
  * Apply consistent style to CMakeLists.txt files
  * Apply consistent style to package.xml files
  * Fix build error in clang error: non-aggregate type 'std::vector' (aka 'vector >') cannot be initialized with an initializer list
  * Multi-update cycle mode switch (#391 <https://github.com/ros-controls/ros_control/issues/391>)
    For more info: https://github.com/pal-robotics-forks/ros_control2/pull/5
    * Added tests for ControllerManager update
    * Mocks for controllers and controller loader in update test
    * Divided in tests with and without controllers
    * Controller state initialized in mock
    * Moved mocks to test class
    * All tests using mock class
    * Test for multiple updates in a single controller
    * Added new switchResult() function to RobotHW interface
    ControllerManager uses this function to wait for the result of the
    doSwitch() before starting the new set of controllers
    * Using ranged based loops
    * Switch is now managed in a separate function
    * Option to start controllers as soon as their joints are ready after a switch
    * Tests for controller_interface API
    * Added new STOPPED, WAITING and ABORTED states to ControllerBase
    * Split manageSwitch() into smaller functions
    * Abort pending controllers in case of switch error
    * Changed default behaviour of new switch param
    This way if it not set it will be the same behaviour as previous version
    * Added timeout parameter to switch controller
    * Removed unnecessary includes
    * Using target_include_directories for the test
    * std::all_of instead of std::count_if
    * Deleted autogenerated file
    * Adapted tests to changes in controller_manager
    * Adapted python implementation to new parameters in SwitchController
    * Added missing parameter description docstring
    * Moved all parameters used for switching to a separate object
    * Moved error messages to controller_base
    * State check functions are now const
    * Removed unnecessary comments
    * Added constants for start_asap and timeout default parameters values
  * Remove extra {
  * Adding Pal Robotics to copyright notice
    Co-Authored-By: Bence Magyar <mailto:bence.magyar.robotics@gmail.com>
  * Added constants for start_asap and timeout default parameters values
  * Moved error messages to controller_base
  * Moved all parameters used for switching to a separate object
  * Added missing parameter description docstring
  * Adapted python implementation to new parameters in SwitchController
  * Deleted autogenerated file
  * std::all_of instead of std::count_if
  * Cosmetics
  * Fixed lincenses
  * Removed unnecessary includes
  * Added timeout parameter to switch controller
  * Changed default behaviour of new switch param
    This way if it not set it will be the same behaviour as previous version
  * Abort pending controllers in case of switch error
  * Split manageSwitch() into smaller functions
  * Added new STOPPED, WAITING and ABORTED states to ControllerBase
  * Option to start controllers as soon as their joints are ready after a switch
  * Switch is now managed in a separate function
  * Using ranged based loops
  * Added new switchResult() function to RobotHW interface


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-controller-manager//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-controller-manager 0.18.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(controller_manager)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED COMPONENTS
  controller_interface
  controller_manager_msgs
  hardware_interface
  pluginlib
  roscpp
)

catkin_python_setup()

# Declare a catkin package
catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    controller_interface
    controller_manager_msgs
    hardware_interface
    pluginlib
    roscpp
)


###########
## Build ##
###########

# Specify header include paths
include_directories(include ${catkin_INCLUDE_DIRS})

add_library(${PROJECT_NAME}
  include/controller_manager/controller_loader.h
  include/controller_manager/controller_loader_interface.h
  include/controller_manager/controller_manager.h
  src/controller_manager.cpp
)
add_dependencies(${PROJECT_NAME} ${catkin_EXPORTED_TARGETS})
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES})


#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)

  add_rostest_gtest(${PROJECT_NAME}_hwi_switch_test
    test/hwi_switch_test.test
    test/hwi_switch_test.cpp
  )
  add_dependencies(${PROJECT_NAME}_hwi_switch_test ${catkin_EXPORTED_TARGETS})
  target_link_libraries(${PROJECT_NAME}_hwi_switch_test ${PROJECT_NAME} ${catkin_LIBRARIES})

  add_rostest_gmock(${PROJECT_NAME}_hwi_update_test
    test/hwi_update_test.test
    test/hwi_update_test.cpp
  )
  add_dependencies(${PROJECT_NAME}_hwi_update_test ${catkin_EXPORTED_TARGETS})
  target_link_libraries(${PROJECT_NAME}_hwi_update_test ${PROJECT_NAME} ${catkin_LIBRARIES})
endif()


#############
## Install ##
#############

# Install python scripts
catkin_install_python(PROGRAMS scripts/controller_group
                               scripts/controller_manager
                               scripts/spawner
                               scripts/unspawner
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Install headers
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

# Install targets
install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

=== debian/changelog ===
ros-melodic-controller-manager (0.18.4-1bionic) bionic; urgency=high

  * Add wall clock timeout to avoid some deadlock situation when switching mode
  * Contributors: krishnachaitanya7

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 15 Jun 2021 23:00:00 -0000

ros-melodic-controller-manager (0.18.3-1bionic) bionic; urgency=high

  * Update docs in hardware_interface
  * Contributors: Franz Pucher

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 05 Dec 2020 00:00:00 -0000

ros-melodic-controller-manager (0.18.2-1bionic) bionic; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 16 Aug 2020 23:00:00 -0000

ros-melodic-controller-manager (0.18.1-1bionic) bionic; urgency=high

  * Add function specifiers and modernize constructors (#430 <https://github.com/ros-controls/ros_control/issues/430>)
    * Add override specifiers & default constructors
    * Delete ControllerBase copy & move ctors
    * Remove unnecessary default constructors
    * Modernize additional constructors
    * Revert ImuSensorHandle::Data::Data() = default
    * Remove unnecessary default overridden constructors
    * Remove semicolon after function body
  * Contributors: Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 08 May 2020 23:00:00 -0000

ros-melodic-controller-manager (0.18.0-1bionic) bionic; urgency=high

  * enable spawner to wait indefinitely if requested (#428 <https://github.com/ros-controls/ros_control/issues/428>)
    rospy.wait_for_service does not allow for 0 to wait indefinitely.
    Instead, None has to be passed explicitly.
    By personal request of three maintainers extended to include documentation
    and the alternative argument --no-timeout.
  * Bump CMake version to avoid CMP0048 (#427 <https://github.com/ros-controls/ros_control/issues/427>)
  * Contributors: Michael Görner, Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 15 Apr 2020 23:00:00 -0000

ros-melodic-controller-manager (0.17.0-1bionic) bionic; urgency=high

  * Use auto keyword
  * Use default member initializers
  * Replace boost with std
  * Replace boost mutexes & locks with std
  * Replace boost::bind with std::bind
  * Contributors: AbhinavSingh, Bence Magyar, Matt Reynolds, suab321321

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 Feb 2020 00:00:00 -0000

ros-melodic-controller-manager (0.16.0-1bionic) bionic; urgency=high

  * Use range-based for loops in controller_manager
  * Resolve Boost dependency issues
  * Update dependencies
    - Dependencies needed to compile are <build_depend>
    - Dependencies used in public headers are <build_export_depend>
    - Dependencies needed to link or run are <exec_depend>
  * Merge branch 'melodic-devel' into catkin-lint
  * Add ${catkin_EXPORTED_TARGETS} dependencies
  * Update package dependencies
  * Add missing roscpp & rospy dependencies
  * Prefer nullptr for null pointers
  * Replace header guard with #pragma once
  * Apply consistent style to CMakeLists.txt files
  * Apply consistent style to package.xml files
  * Fix build error in clang error: non-aggregate type 'std::vector' (aka 'vector >') cannot be initialized with an initializer list
  * Multi-update cycle mode switch (#391 <https://github.com/ros-controls/ros_control/issues/391>)
    For more info: https://github.com/pal-robotics-forks/ros_control2/pull/5
    * Added tests for ControllerManager update
    * Mocks for controllers and controller loader in update test
    * Divided in tests with and without controllers
    * Controller state initialized in mock
    * Moved mocks to test class
    * All tests using mock class
    * Test for multiple updates in a single controller
    * Added new switchResult() function to RobotHW interface
    ControllerManager uses this function to wait for the result of the
    doSwitch() before starting the new set of controllers
    * Using ranged based loops
    * Switch is now managed in a separate function
    * Option to start controllers as soon as their joints are ready after a switch
    * Tests for controller_interface API
    * Added new STOPPED, WAITING and ABORTED states to ControllerBase
    * Split manageSwitch() into smaller functions
    * Abort pending controllers in case of switch error
    * Changed default behaviour of new switch param
    This way if it not set it will be the same behaviour as previous version
    * Added timeout parameter to switch controller
    * Removed unnecessary includes
    * Using target_include_directories for the test
    * std::all_of instead of std::count_if
    * Deleted autogenerated file
    * Adapted tests to changes in controller_manager
    * Adapted python implementation to new parameters in SwitchController
    * Added missing parameter description docstring
    * Moved all parameters used for switching to a separate object
    * Moved error messages to controller_base
    * State check functions are now const
    * Removed unnecessary comments
    * Added constants for start_asap and timeout default parameters values
  * Remove extra {
  * Adding Pal Robotics to copyright notice
    Co-Authored-By: Bence Magyar <mailto:bence.magyar.robotics@gmail.com>
  * Added constants for start_asap and timeout default parameters values
  * Moved error messages to controller_base
  * Moved all parameters used for switching to a separate object
  * Added missing parameter description docstring
  * Adapted python implementation to new parameters in SwitchController
  * Deleted autogenerated file
  * std::all_of instead of std::count_if
  * Cosmetics
  * Fixed lincenses
  * Removed unnecessary includes
  * Added timeout parameter to switch controller
  * Changed default behaviour of new switch param
    This way if it not set it will be the same behaviour as previous version
  * Abort pending controllers in case of switch error
  * Split manageSwitch() into smaller functions
  * Added new STOPPED, WAITING and ABORTED states to ControllerBase


=== debian/control ===
Source: ros-melodic-controller-manager
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-controller-interface, ros-melodic-controller-manager-msgs, ros-melodic-hardware-interface, ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-rostest
Homepage: https://github.com/ros-controls/ros_control/wiki
Standards-Version: 3.9.2

Package: ros-melodic-controller-manager
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-controller-interface, ros-melodic-controller-manager-msgs, ros-melodic-hardware-interface, ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-rosparam, ros-melodic-rospy, ros-melodic-std-msgs
Description: The controller manager.
